package com.myarch.antassert;

import org.apache.commons.logging.Log;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;

import com.myarch.antutil.AntCommonsLogger;
import com.myarch.dpbuddy.ant.BaseDPBuddyTask;

public class AssertEquals extends Task {
    private Log logger;

    
    private String property;
    private String value;

    public void setProperty( String property ) {
        this.property=property;
    }

    public void setValue( String value ) {
        this.value=value;
    }

    public AssertEquals() {
        logger=AntCommonsLogger.init( BaseDPBuddyTask.ROOT_LOGGER );
    }

    @Override
    public void execute() throws BuildException {
        BaseDPBuddyTask.setUpLogging( getProject() );

        String propValue=getProject().getProperty( property );
        if (propValue == null)
            throw new BuildException( "Property " + property + " is undefined" );

        if (!propValue.equals( value ))
            throw new BuildException(
                            String.format( "Assertion failed. Property '%s' has value '%s' which is not equal to the expected value '%s'",
                                            property, propValue, value ) );
        logger.info( property + ": " + propValue );

        AntCommonsLogger.deregister();
    }

}
