package com.myarch.antutil;

import java.util.HashMap;
import java.util.Map;

import org.apache.tools.ant.Project;
import org.apache.tools.ant.RuntimeConfigurable;

public class RuntimeConfigurableHelper {

    private RuntimeConfigurable runtimeConfigurable;
    private Project project;
    
    
    public RuntimeConfigurableHelper(Project project, RuntimeConfigurable runtimeConfigurable) {
        super();
        this.project=project;
        this.runtimeConfigurable=runtimeConfigurable;
    }
    
    public String getAttrValue(String attrName){
        
        String val=(String)runtimeConfigurable.getAttributeMap().get(attrName);
        if (val!=null)
            val=project.replaceProperties(val);
        
        return val;
    }
    
    public Map<String, String> getAttrs() {
        Map<String, String> attrMap=new HashMap<String, String>();
        
        Map<String, Object> attributes=runtimeConfigurable.getAttributeMap();
        for(Map.Entry<String, Object> attr: attributes.entrySet()) {
            Object val=attr.getValue();
            if (val instanceof String) {
                val=project.replaceProperties(val.toString());
            }
            attrMap.put(attr.getKey(), val.toString());
        }
        
        return attrMap;
    }
    
    
  
    
}
