package com.myarch.dpbuddy;

public class DPObjectsNotFoundException extends DPBuddyException {

    private boolean isRollback=false;
    
    public DPObjectsNotFoundException(String msg, Object ... args) {
        super(makeMessage( msg, args));
    }
    
    public DPObjectsNotFoundException(Throwable e) {
        super(e);
    }
    
    public DPObjectsNotFoundException(String msg, Throwable e, Object ... args) {
        super(makeMessage( msg, args), e);
    }
    
    
    public boolean isRollback() {
        return isRollback;
    }

    public void setRollback( boolean isRollback ) {
        this.isRollback=isRollback;
    }

    private static String makeMessage( String message, Object ...  args){
        if (args.length==0)
            return message;
        else
            return String.format(message, args);
    }
    
    
    
    private static final long serialVersionUID = 1L;
    
}
