package com.myarch.dpbuddy;

import java.io.InputStream;

import org.jdom2.Document;
import org.jdom2.Element;

public interface DPRequest {
    
    /**
     * Returns the root element of the SOMA request ("request").
     * The method returns JDom but it can be easily converted to DOM or SAX:
     * http://www.ibm.com/developerworks/xml/library/x-tipcjdm.html
     *  
     * @return JDom Element object of the "request" element. 
     */
    Element getRequestElement();
    
    /**
     * Returns a human-readable name for logging
     * @return display name
     */
    String getDisplayName();
    
    Document getDocument();
    
    InputStream getInputStream();

}
