package com.myarch.dpbuddy;

import java.util.List;

import org.jdom2.Element;

import com.myarch.dpbuddy.config.DPConfiguration;
import com.myarch.dpbuddy.dpimport.ImportCommand;
import com.myarch.dpbuddy.xmlutil.XMLInput;

/**
 * Handles deployment policy for export and import
 */
public class DeploymentPolicyRequest extends BaseRequest{
    
    private ImportCommand policyImportCommand;
    
        
    public DeploymentPolicyRequest() {
        super();
    }
    

    private Element getExportImportElement() {
        Element requestElt=getRequestElement();
        List<Element> children = requestElt.getChildren();
        if (children.size()>1)
            throw new IllegalStateException("Found multiple export/import elements");
        return children.get(0);
    }
    
    public void setDeploymentPolicyFile(XMLInput xmlInput ){
        policyImportCommand=new ImportCommand();
        policyImportCommand.setFile( xmlInput);
        DPConfiguration deploymentPolicyConfiguration = new DPConfiguration(xmlInput);

        setDeploymentPolicyName(deploymentPolicyConfiguration.getName());
    }

    public void setDeploymentPolicyName(String name ){
        getExportImportElement().setAttribute("deployment-policy", name);
    }
    
    public void setDeploymentPolicyVariablesName(String name ){
        getExportImportElement().setAttribute("deployment-policy-variables", name);
    }
    
    public String getDeploymentPolicyName() {
        return getExportImportElement().getAttributeValue("deployment-policy");
    }
  
    public ImportCommand getDeploymentPolicyConfigCommand() {
        return policyImportCommand;
    }
    
    public boolean hasDeploymentPolicy() {
        return policyImportCommand!=null;
    }
}
