package com.myarch.dpbuddy;

import java.util.List;

import org.jdom2.Element;

public class LogEventContainer {
    
    private Element logEventParentElt;
    
    public LogEventContainer( ){
    }

    public LogEventContainer( Element logEventParentElt ){
        this.logEventParentElt=logEventParentElt;
    }

    /**
     * Creates log event container with the log events that are children of the 
     * provided element
     * @param logElt element containing events -- it's either "log-error" for result response or "log" for import response
     */
    public void setLogEventParentElement( Element logEventParentElt ){
        this.logEventParentElt=logEventParentElt;
    }
    
    public String getLogEventsStr(){
        if (logEventParentElt==null)
            return "";
        
        List<Element> logEvents = (List<Element>)logEventParentElt.getChildren("log-event");

        StringBuilder buf = new StringBuilder();
        for( Element logEvent : logEvents){
            buf.append(logEvent.getTextTrim()+"\n");
        }
        return buf.toString();
    }

    /**
     * @return True if this log event container contains at lest one event
     */
    public boolean hasLogEvents() {
        return logEventParentElt!=null && logEventParentElt.getChildren("log-event").size()>0;
    }
    
}
