package com.myarch.dpbuddy;

import java.util.ArrayList;
import java.util.List;

import org.apache.commons.lang3.StringUtils;

public class ObjectListParser {

    public static List<DPObject> parsePatternList( String patternList ) {
        List<DPObject> objects=new ArrayList<DPObject>();
        String[] elementsWithColons=StringUtils.split( patternList, ',' );
        for (String elementWithColon : elementsWithColons) {
            String[] classAndName=StringUtils.splitPreserveAllTokens( elementWithColon.trim(), ':' );
            String className=null;
            String objectName=null;
            if (classAndName.length > 0) {
                // class only
                if (classAndName.length==1) {
                    if (StringUtils.isNotBlank(classAndName[0]) ) {
                        className=classAndName[0].trim();   
                    }
                }
                else if(classAndName.length==2){
                    if (StringUtils.isNotBlank(classAndName[0]) ) {
                        className=classAndName[0].trim();   
                    }
                    
                    if (StringUtils.isNotBlank(classAndName[1]) ) {
                        objectName=classAndName[1].trim();   
                    }
                }
                else  {
                    throw new DPBuddyException ("Invalid token '%s' containing multiple ':', only one ':' separator is allowed", elementWithColon);
                }
                
                if (objectName!=null && !objectName.startsWith( "(")) {
                    objectName="(?i)"+objectName;
                }
                objects.add( new DPObject( className, objectName ) );
            }
        }

        return objects;
    }

}
