package com.myarch.dpbuddy;

import org.jdom2.Element;

/**
 * A single result item containing the status and, optionally, log entries.
 * ResultResponse contains multiple result items.
 */
public class ResultResponseItem {
    private String status;
    private LogEventContainer logEventContainer=new LogEventContainer();

    private int index;

    public ResultResponseItem(Element resultElt, int index) {

        status=resultElt.getText().trim();

        Element errorLogElt=resultElt.getChild( "error-log" );
        if (errorLogElt != null)
            logEventContainer.setLogEventParentElement( errorLogElt );

        this.index=index;

    }

    public String getStatus() {
        return status;
    }

    public boolean isSuccess() {
        return "OK".equals( status );
    }

    public String getLogEventsStr() {
        return logEventContainer.getLogEventsStr();
    }

    public int getIndex() {
        return index;
    }

}
