package com.myarch.dpbuddy.action;

import org.apache.commons.lang3.StringUtils;
// Use it only for actoions without attributes
public enum ActionTaskMetadata {
    
    RESET_DOMAIN("resetDomain", "ResetThisDomain", true), 
    RESTART_DOMAIN("restartDomain", "RestartThisDomain", false);

    private String taskName;
    private String actionName;
    private String attrName;
    private String childElementName;
    private boolean isCreateAuditEvent=false;

    private ActionTaskMetadata(String taskName, String actionName, String attrName,
                    String childElementName) {
        this( taskName, actionName, false );
        this.attrName=attrName;
        this.childElementName=childElementName;
    }

    private ActionTaskMetadata(String taskName, String actionName, boolean createAuditEvent) {
        this.taskName=taskName;
        this.actionName=actionName;
        this.isCreateAuditEvent=createAuditEvent;
    }

    public String getActionName() {
        return actionName;
    }

    public String getAttrName() {
        return attrName;
    }

    public String getChildElementName() {
        return childElementName;
    }

    public boolean hasChildElement() {
        return childElementName != null;
    }
    
    
    public boolean isCreateAuditEvent() {
        return isCreateAuditEvent;
    }

    /**
     * returns task name without prefix
     * @return
     */
    public String getTaskName() {
        return taskName;
    }
    
    public static ActionTaskMetadata fromTaskName( String taskName ) {
        if (taskName.contains( ":" ))
            taskName=StringUtils.substringAfter( taskName, ":");
        for (ActionTaskMetadata taskMetadata : ActionTaskMetadata.values()) {
            if (taskMetadata.taskName.equalsIgnoreCase( taskName ))
                return taskMetadata;
        }

        throw new IllegalArgumentException( "Didn't find action definition for the task " + taskName );
    }

}
