package com.myarch.dpbuddy.action;

import org.apache.tools.ant.BuildException;

import com.myarch.antutil.RuntimeConfigurableHelper;
import com.myarch.dpbuddy.DPBuddyException;
import com.myarch.dpbuddy.ant.BaseDPBuddyTask;
import com.myarch.dpbuddy.audit.AuditEvent;

public class MetadataDrivenActionAntTask extends BaseDPBuddyTask {

    // this tells Ant not to throw an exception when we have unrecognized
    // attributes
    public void maybeConfigure() throws BuildException {
    }

    @Override
    public void executeDPTask() throws BuildException {
        ActionTaskMetadata metadata=ActionTaskMetadata.fromTaskName( getTaskName() );
        ActionCommand actionCommand=new ActionCommand();
        // FIXME: we ask for child element but what if the task only has an attribute?
        if (metadata.hasChildElement()) {
            RuntimeConfigurableHelper runtimeConfiguration=new RuntimeConfigurableHelper( getProject(),
                            getRuntimeConfigurableWrapper() );
            String childValue=runtimeConfiguration.getAttrValue( metadata.getAttrName() );
            if (childValue == null) {
                throw new DPBuddyException( "You must set attribute '%s' for this task",
                                metadata.getAttrName() );
            }
            actionCommand.addAction( metadata.getActionName(), metadata.getChildElementName(),
                            childValue );
        }
        else {
            actionCommand.addAction( metadata.getActionName() );
        }

        executeRequest( actionCommand );
        
        if (metadata.isCreateAuditEvent() && auditEventHandler!=null) {
            AuditEvent auditEvent=createAuditEvent(metadata.getTaskName());
            auditEventHandler.handleAuditEvent(auditEvent, getDevice());
        }
        saveDomainConfigIfEnabled();
    }

}
