package com.myarch.dpbuddy.action;

import org.apache.tools.ant.BuildException;
import org.kohsuke.args4j.Option;

import com.myarch.dpbuddy.ant.BaseDPBuddyTask;

/**
 * Pings remote host from DataPower
 */
public class PingAntTask extends BaseDPBuddyTask {

    private String host;

    @Option(name="-remoteHost", aliases="-rh", required=true, usage="Host or IP to ping from DataPower")
    public void setRemoteHost( String host ) {
        this.host=host;
    }

    @Override
    public void executeDPTask() throws BuildException {
        ActionCommand actionCommand=new ActionCommand( "Ping" );
        actionCommand.addActionChildElement( "RemoteHost", host );

        actionCommand.execute( getDevice() );
        logger.info( String.format("Host '%s' was successfully pinged from DataPower '%s'", host, getDevice().getDPConnection().getHost()) );
    }
}
