package com.myarch.dpbuddy.action;


import org.apache.tools.ant.BuildException;
import org.kohsuke.args4j.Option;

/**
 * Executes "save" action
 */
public class SaveAntTask extends ActionAntTask{
    
    private String domainPatternsString;

    @Option(name="-domainPatterns", aliases="-domains",
                    usage="Comma-delimited list of regular expression patterns defining what domains to apply the command to. Use '.*' for all domains except the default. Use '.*,default' to include the default.")
    public void setDomainPatterns( String domainPatterns ) {
        this.domainPatternsString=domainPatterns;
    }
    
    @Override
    protected String getDomainPatterns() {
        return domainPatternsString;
    }    

    public void execute() throws BuildException {
        setName("SaveConfig");
        super.execute();
    }
    
}
