package com.myarch.dpbuddy.action;

import java.util.List;

import org.apache.commons.lang3.tuple.Pair;
import org.apache.tools.ant.BuildException;
import org.kohsuke.args4j.Option;

import com.myarch.dpbuddy.ant.BaseDPBuddyTask;
import com.myarch.util.NameValueListParser;

public class TcpConnectionTestAntTask extends BaseDPBuddyTask {
    
    private String hostPortList;

    @Option(name="-hostPort", aliases="-rh", usage="List of comma-delimited host:port, e.g., my.backend.com:443,192.168.1.12:8080. Port 443 is the default.")
    public void setHostPort( String hoconStr ) {
        this.hostPortList=hoconStr;

    }

    @Override
    public void executeDPTask() throws BuildException {

        List<Pair<String, String>> hostPorts=NameValueListParser.parse( hostPortList, "443");
        for (Pair<String, String> hostPort:hostPorts) {
            int port=Integer.parseInt( hostPort.getRight() );
            String host=hostPort.getKey();
            testHostPort(host, port);
        }
        
    }

    private void testHostPort(String host, int port) {
        ActionCommand actionCommand=new ActionCommand( "TCPConnectionTest" );
        actionCommand.addActionChildElement( "RemoteHost", host );
        actionCommand.addActionChildElement( "RemotePort", Integer.toString( port ) );

        actionCommand.execute( getDevice() );
        logger.info( String.format("'%s:%d' is reachable and open from DataPower host '%s'", host, port, getDevice().getDPConnection().getHost()) );
        
    }
}
