package com.myarch.dpbuddy.ant;

import java.util.ArrayList;
import java.util.List;

import org.apache.tools.ant.DynamicElementNS;
import org.apache.tools.ant.types.DataType;
import org.apache.tools.ant.util.XMLFragment;
import org.jdom2.Document;
import org.jdom2.Element;

import com.myarch.dpbuddy.DPBuddyException;
import com.myarch.dpbuddy.xmlutil.XMLInput;

public class DataPowerConfigurationType extends DataType implements DynamicElementNS {
    
    // Ant support - ant uses marker iface DynamicElementNS; if it's present, it will invoke createDynamicElement 
    private List<XMLFragment> xmlFragments=new ArrayList<XMLFragment>();
    
    public Object createDynamicElement(String uri, String name, String qName) {
        XMLFragment xmlFragment=new XMLFragment();
        // Bug in Ant -- it doesn't do it automatically
        xmlFragment.setProject(getProject());
        xmlFragments.add(xmlFragment);

        return xmlFragment.createDynamicElement(uri, name, qName);
    }
    
    public XMLInput getConfigurationXml(){
        Document doc = new Document();
        Element dpConfigElt = new Element("datapower-configuration");
        Element configElt = new Element("configuration");
        dpConfigElt.addContent( configElt );
        doc.addContent( dpConfigElt );
        
        List<XMLInput> xmls=new ArrayList<XMLInput>();
        for (XMLFragment xmlFragment:xmlFragments){
            XMLInput xmlInput=new XMLInput(xmlFragment.getFragment());
            xmlInput.clearAntlibNamespace();
            xmls.add(xmlInput);
        }
            
        if (xmls.size()==0) {
            throw new DPBuddyException("You must provide nested XML inside 'configuration'");
        }
    
        List<Element> elts=XMLInput.asDetachedElements( xmls );
        configElt.addContent(elts);
        
        return new XMLInput(doc);
    }

}
