package com.myarch.dpbuddy.anysoma;

import java.util.List;

import org.jdom2.Document;
import org.jdom2.Element;

import com.myarch.dpbuddy.BaseRequest;
import com.myarch.dpbuddy.BaseResponse;
import com.myarch.dpbuddy.DPCommand;
import com.myarch.dpbuddy.Device;
import com.myarch.dpbuddy.ResultResponse;
import com.myarch.dpbuddy.xmlutil.JDomUtils;
import com.myarch.dpbuddy.xmlutil.XMLInput;

/**
 * Executes an arbitrary XML SOMA file
 */
public class AnySOMARequestCommand implements DPCommand<BaseResponse> {

    private BaseRequest request=new BaseRequest();

    public AnySOMARequestCommand(XMLInput xml) {
        request.setDocument( xml.getDocument() );
    }

    public BaseResponse execute( Device device ) {
        BaseResponse response=null;

        Document responseDoc=device.executeRequest( request );
        List<Element> elts=JDomUtils.findDPElements( responseDoc, "//dp:result" );
        if (elts.size() > 0) {
            ResultResponse resultResponse=new ResultResponse( responseDoc );
            resultResponse.validate();
            response=resultResponse;
        }
        else {
            response=new BaseResponse( responseDoc );
        }
        
        return response;
    }

    public String getRequestName() {
        return request.getDisplayName();
    }

    @Override
    public String toString() {
        return request.toString();
    }

}
