package com.myarch.dpbuddy.cache;

import org.apache.commons.lang3.StringUtils;
import org.apache.tools.ant.BuildException;
import org.kohsuke.args4j.Option;

import com.myarch.dpbuddy.action.ActionCommand;
import com.myarch.dpbuddy.ant.BaseDPBuddyTask;

/**
 * Flushes various caches in DataPower:
 * ,FlushArpCache,FlushDNSCache,FlushNDCache,FlushRBMCache
 * 
 * TODO: support for FlushNSSCache FlushPDPCache Note: ARP and ND caches are not
 * supported by the virtual appliance, at least not in 6.0.
 */
public class FlushMiscCacheAntTask extends BaseDPBuddyTask {

    private String cacheTypesStr;

    @Option(
                    name="-cacheTypes",
                    usage="Comma-delimited list of cache types. A cache type must be one of the following:DNS, RBM, ND")
    public void setCacheTypes( String cacheTypes ) {
        this.cacheTypesStr=cacheTypes;
    }

    @Override
    public void executeDPTask() throws BuildException {
        validator.validateRequired( cacheTypesStr, "cacheTypes", "Cache types: Arp, DNS, ND, RBM" );

        ActionCommand actionCommand=new ActionCommand();
        String[] cacheTypes=StringUtils.split( cacheTypesStr, ',' );

        for (String cacheType : cacheTypes) {
            String action="Flush" + cacheType.trim() + "Cache";
            actionCommand.addAction( action );
        }

        executeRequest( actionCommand );
    }

}
