package com.myarch.dpbuddy.cache;

import org.apache.commons.lang3.StringUtils;

public enum XMLCacheType {
    DOCUMENT("FlushDocumentCache"),
    STYLESHEET("FlushStylesheetCache"),
    ALL(null);
    
    private String actionName;
    
    XMLCacheType(String actionName) {
        this.actionName = actionName;
    }

    public String getActionName() {
        return actionName;
    }

    
    public static XMLCacheType fromTaskName(String taskName){
        if ( StringUtils.containsIgnoreCase( taskName, DOCUMENT.toString() ) )
            return DOCUMENT;
        if ( StringUtils.containsIgnoreCase( taskName, STYLESHEET.toString() ) )
            return STYLESHEET;
        
        if ( StringUtils.containsIgnoreCase( taskName, "XMLCache" ) )
            return ALL;
        
        throw new IllegalArgumentException("Invalid task name to derive XML cache type from: "+taskName);
                        
    }
}
