package com.myarch.dpbuddy.checkpoint;

import org.apache.tools.ant.BuildException;
import org.kohsuke.args4j.Option;

import com.myarch.dpbuddy.ant.BaseDPBuddyTask;
import com.myarch.dpbuddy.audit.AuditEvent;

public class RollbackCheckpointAntTask extends BaseDPBuddyTask {

    private String name;

    @Option(name="-name", usage="Name of the checkpoint to rollback to.")
    public void setName( String name ) {
        this.name=name;
    }

    @Override
    public void executeDPTask() throws BuildException {

        RollbackCheckpointCommand actionRequest=new RollbackCheckpointCommand( name );
        executeRequest( actionRequest );

        if (auditEventHandler != null) {
            AuditEvent auditEvent=createAuditEvent( "rollback" );
            auditEventHandler.handleAuditEvent( auditEvent, getDevice() );
        }

        saveDomainConfigIfEnabled();
    }

}
