package com.myarch.dpbuddy.cli;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.TreeMap;

import org.apache.commons.lang.StringUtils;

import com.myarch.dpbuddy.ant.BaseDPBuddyTask;

// TODO: determine similar commands

public class CliCommandDefContainer {
    private Map<String, CliCommandDef> commandMap=new TreeMap<>(String.CASE_INSENSITIVE_ORDER);
    
    public void add(CliCommandDef cmdDef) {
        commandMap.put( cmdDef.getName(), cmdDef );
    }
    
    public void add(String name, BaseDPBuddyTask antTask) {
        add(new CliCommandDef( name, antTask ));
    }
    
    public CliCommandDef get(String name){
        return commandMap.get( name );
    }
    
    
    public String getSupportedCommandStrList() {
        Set<String> cmds=commandMap.keySet();
        List<String> sortedCmds=new ArrayList<String>( cmds );
        Collections.sort( sortedCmds );
        String cmdStrList=StringUtils.join( sortedCmds, ", " );
        return cmdStrList;
    }
}
