package com.myarch.dpbuddy.cli;


import java.io.File;
import java.util.Iterator;

import org.apache.commons.configuration.AbstractConfiguration;
import org.apache.commons.configuration.Configuration;
import org.apache.commons.configuration.ConfigurationException;
import org.apache.commons.configuration.PropertiesConfiguration;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.tools.ant.Project;

public class Config {
    private final Log logger=LogFactory.getLog( getClass() );
    
    private PropertiesConfiguration config;
    
    
    public Config(File configPropFile) {
        
        try {
            config=new PropertiesConfiguration(configPropFile);
        }
        catch (ConfigurationException e) {
            throw new RuntimeException(e);
        }
        ( (AbstractConfiguration) config ).setThrowExceptionOnMissing( true );
    }

    
    public Configuration getConfiguration() {
        return config;
    }
    
    public String get(String propName){
        return config.getString(propName);
    }
    
    public int getInt(String propName){
        return config.getInt(propName);
    }
    
    public void addConfigPropsToAntProject(Project project) {
        Iterator<String> keys=config.getKeys();
        int i=0;
        while(keys.hasNext()) {
            String key=keys.next();
            project.setProperty( key, project.replaceProperties( get(key) ));
            ++i;
        }
        logger.debug( "Added "+i+" properties from file "+config.getPath() );
    }

}
