package com.myarch.dpbuddy.client;

import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.jdom2.Document;
import org.jdom2.Element;

import com.myarch.dpbuddy.xmlutil.JDomUtils;

public class SOAPUtil {
    
    @SuppressWarnings("unused")
    private static Log logger = LogFactory.getLog(SOAPUtil.class);

    
    public static String extractSOAPFaultReason(Document doc ) {
        String faultReason = null;
        List<Element> faultNodes = JDomUtils.findDPElements( doc, "//faultstring" );
        if (faultNodes.size()>0) {
            Element faultReasonNode = faultNodes.get(0);
            faultReason = faultReasonNode.getText();
        }

        List<Element> resultElts = JDomUtils.findDPElements( doc, "//dp:result" );
        if ( resultElts.size() == 1 ) {
            String resultText = resultElts.get(0).getText();
            if (resultText.contains("failure"))
                faultReason = resultText;
        }
        
        return faultReason;

    }

}
