package com.myarch.dpbuddy.dpimport;

import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.myarch.dpbuddy.DPBuddyException;

public class ImportException  extends DPBuddyException{

    private Log logger = LogFactory.getLog(getClass());
    
    private List<ImportedObject> failedObjects;
    
    public ImportException( List<ImportedObject> failedObjects ) {
        super(ImportException.makeErrorMessage(failedObjects));
        this.failedObjects=failedObjects;
    }
    
    private static String makeErrorMessage( List<ImportedObject> failedObjects ) {
        StringBuilder buf=new StringBuilder();
        for(ImportedObject failedObj: failedObjects) {
            String msg=String.format("\nImport of object '%s' failed with the status '%s'", failedObj.toClassObjectStr(), failedObj.getStatus());
            buf.append(msg);
            
            if (failedObj.hasLogEvents() ) {
                buf.append("\nLog entries:\n"+failedObj.getLogEventsStr());
            }
        }
        
        return buf.toString();
    }
    
    public void log() {
        logger.info(getMessage());
    }
    
    public List<ImportedObject> getFailedObjects() {
        return failedObjects;
    }
    
    private static final long serialVersionUID = 4164001125642528805L;
}
