package com.myarch.dpbuddy.dpimport;

import java.util.List;

import org.apache.commons.io.FilenameUtils;
import org.jdom2.Element;

import com.myarch.dpbuddy.xmlutil.JDomUtils;

public class ImportedFile {
    private String path;
    private String result;
    @SuppressWarnings("unused")
    private String reason;

    ImportedFile(Element fileResultElement) {
        path=JDomUtils.getRequiredAttributeValue( fileResultElement, "name" );
        result=JDomUtils.getRequiredAttributeValue( fileResultElement, "result" );
    }

    public boolean isInStatus( Status status ) {
        switch (status) {
        case FAILURE:
            return isFailure();
        case OK:
            return isOK();
        case IGNORED:
            return isIgnored();
        }

        throw new IllegalArgumentException( "Enum " + status + " is not accounted for" );
    }

    public boolean isFailure() {
        return !isOK() && !isIgnored();

    }

    public boolean isOK() {
        return result.equals( "OK" );
    }

    public boolean isIgnored() {
        return result.equals( "ignored" );
    }

    public String getPath() {
        return path;
    }

    public static String fileListToString( List<ImportedFile> files ) {
        StringBuilder buf=new StringBuilder();
        for (ImportedFile file : files) {
            if (buf.length() > 0)
                buf.append( "\n" );
            buf.append( FilenameUtils.normalize( file.getPath(), true ));
        }

        return buf.toString();
    }

    public enum Status {
        IGNORED, OK, FAILURE;
    }

}
