package com.myarch.dpbuddy.dpimport;


import org.jdom2.Element;

import com.myarch.dpbuddy.DPObject;
import com.myarch.dpbuddy.LogEventContainer;
import com.myarch.dpbuddy.xmlutil.JDomUtils;

public class ImportedObject extends DPObject {
    
    private String status;
    private LogEventContainer logEventContainer=new LogEventContainer();
    
    ImportedObject(Element cfgResultElement) {
        super();
        setName(JDomUtils.getRequiredAttributeValue( cfgResultElement, "name"));
        setClass(JDomUtils.getRequiredAttributeValue( cfgResultElement, "class"));
        status=JDomUtils.getRequiredAttributeValue( cfgResultElement, "status");
        Element  errorLogElt = cfgResultElement.getChild("log");
        if (errorLogElt!=null)
            logEventContainer.setLogEventParentElement(errorLogElt);

    }
    
    
    public boolean isInStatus(Status status){
        switch(status){
            case FAILURE:
                return isFailure();
            case SUCCESS:
                return isSuccess();
            case SKIPPED:
                return isSkipped();
        }
        
        throw new IllegalArgumentException("Enum "+status+" is not accounted for");
    }
    
    
    public boolean isSuccess(){
        return status.equalsIgnoreCase("success");
    }
    
    public boolean isSkipped() {
        return status.equalsIgnoreCase("skipped") || status.trim().length()==0;
    }

    public boolean isFailure(){
        return !isSuccess()&&!isSkipped();
    }

    public String getStatus(){
        return status;
    }
    
    public String getLogEventsStr() {
        return logEventContainer.getLogEventsStr();
    }
    
    public boolean hasLogEvents() {
        return logEventContainer.hasLogEvents();
    }
    
    
    public enum Status{ 
        SKIPPED, SUCCESS, FAILURE;
    }
    
}

