package com.myarch.dpbuddy.encryption;

import org.apache.tools.ant.BuildException;
import org.kohsuke.args4j.Option;

import com.myarch.antutil.AntCommonsLogger;
import com.myarch.dpbuddy.ant.BaseDPBuddyTask;
import com.myarch.util.DecryptionUtils;

public class DecryptAntTask extends BaseDPBuddyTask {

    public DecryptAntTask() {
        AntCommonsLogger.init( BaseDPBuddyTask.ROOT_LOGGER );
    }

    private String encrypted;
    private String masterPassword;
    private String property;

    @Option(name="-encrypted", usage="Value to decrypt", required=true)
    public void setEncrypted( String encrypted ) {
        this.encrypted=encrypted;
    }

    public void setProperty( String property ) {
        this.property=property;
    }

    @Option(name="-passwd", usage="Password used for encryption/decryption")
    public void setPasswd( String masterPassword ) {
        this.masterPassword=masterPassword;
    }

    @Override
    public void execute() throws BuildException {
        BaseDPBuddyTask.setUpLogging( getProject() );

        if (encrypted == null)
            throw new BuildException( "You must provide 'encrypted' attribute" );

        try {

            String decrypted;
            if (masterPassword != null) {
                decrypted=DecryptionUtils.decryptIfEncrypted( encrypted, masterPassword );
            }
            else {
                decrypted=DecryptionUtils.decryptIfEncrypted( encrypted );
            }
            if (property != null) {

                getProject().setProperty( property, decrypted );
            }
            else {
                System.out.print(decrypted  );
            }
        }
        finally {
            AntCommonsLogger.deregister();
        }
    }

    @Override
    protected void executeDPTask() {

    }

}
