package com.myarch.dpbuddy.encryption;

import org.apache.tools.ant.BuildException;
import org.kohsuke.args4j.Option;

import com.myarch.antutil.AntCommonsLogger;
import com.myarch.dpbuddy.ant.BaseDPBuddyTask;
import com.myarch.util.DecryptionUtils;

public class EncryptAntTask extends BaseDPBuddyTask{
    
    public EncryptAntTask() {
        AntCommonsLogger.init( BaseDPBuddyTask.ROOT_LOGGER );
    } 
    
    private String password;
    private String stringToEncrypt;
    
    @Option(name="-passwd", usage="Password used for encryption/decryption", required=false)
    public void setPasswd( String password ) {
        this.password=password;
    }
    
    @Option(name="-value", usage="Value to encrypt", required=true)
    public void setValue( String stringToEncrypt ) {
        this.stringToEncrypt=stringToEncrypt;
    }


    @Override
    public void execute() throws BuildException {
        BaseDPBuddyTask.setUpLogging( getProject() );
        
        if (stringToEncrypt == null)
            throw new BuildException( "You must provide 'value' attribute");
        
        try{
            String encrypted;
            if (password != null) {
                encrypted=DecryptionUtils.encryptAndWrap(stringToEncrypt, password);
            }
            else {
                encrypted=DecryptionUtils.encryptAndWrap( stringToEncrypt );
            }           
            System.out.println( "Encrypted string:\n"+encrypted );
        }
        finally {
            AntCommonsLogger.deregister();
        }
    }

    @Override
    protected void executeDPTask() {
        
    }

}
