package com.myarch.dpbuddy.event;

import java.util.Date;

import org.apache.commons.lang3.StringUtils;

import com.google.gson.JsonObject;
import com.myarch.dpbuddy.Device;
import com.myarch.eventmodel.Event;
import com.myarch.eventmodel.EventType;

public class EventCreator {

    public final static String DP_OBJECT="dp";

    public Event createDataPowerEvent( Device device, String domain, EventType eventType ) {

        Event event=new Event( "DataPower", eventType, device.getDPConnection().getUrl() );
        event.setTimestamp( new Date() );
        if (StringUtils.isNotBlank( device.getName() )) {
            event.setNode( device.getName() );
        }
        JsonObject dpJson=createDpEventProps( domain );
        event.json().add( DP_OBJECT, dpJson );

        return event;
    }

    private JsonObject createDpEventProps( String domain ) {
        JsonObject json=new JsonObject();
        json.addProperty( "domain", domain );

        return json;
    }

}
