package com.myarch.dpbuddy.event;

import org.apache.commons.lang3.StringUtils;

import com.google.gson.JsonObject;
import com.myarch.eventmodel.Event;
import com.myarch.util.JsonUtils;

public class EventUtils {

    public static JsonObject getDpJson( Event event ) {
        return getDpJson( event.json() );
    }

    public static JsonObject getDpJson( JsonObject eventJson ) {
        return eventJson.getAsJsonObject( EventCreator.DP_OBJECT );
    }
    
    public static void setDomain(JsonObject json, String domain){
        JsonObject dpJson=EventUtils.getDpJson( json );
        dpJson.addProperty( DOMAIN_FIELD, domain );       
    }
    
    public static boolean containsDomain( JsonObject eventJson ) {
        JsonObject dpJson=EventUtils.getDpJson( eventJson );
        return dpJson.has( DOMAIN_FIELD );
    }

    public static boolean isCategory( JsonObject eventJson, String category ) {
        String eventCategory=JsonUtils.getString( eventJson, CATEGORY_FIELD );
        return StringUtils.equalsIgnoreCase( eventCategory, category );
    }
    
    
    public final static String DOMAIN_FIELD="domain";
    public final static String CATEGORY_FIELD="category";

}
