package com.myarch.dpbuddy.export;

import org.jdom2.Element;

import com.myarch.dpbuddy.DPConst;
import com.myarch.dpbuddy.DeploymentPolicyRequest;
import com.myarch.dpbuddy.ExportImportFileType;
import com.myarch.util.FilePathUtils;

/**
 * Base class for Export and Backup 
 */
public class ExportBackupBase extends DeploymentPolicyRequest {
    
    private String toFile;
    private ExportImportFileType format=ExportImportFileType.ZIP;
    
    private Element exportBackupElement;

    private boolean appendTimestamp = false;

    public ExportBackupBase( String somaOperation ) {
        createExportBackupElement( somaOperation );
    }
    

    public void setToFile( String file ) {
        this.toFile = FilePathUtils.toCanonicalPath(file);
        format = ExportImportFileType.fromFile(this.toFile);
        exportBackupElement.setAttribute("format", format.toString());
    }
    
    public void setPersisted( boolean persisted ){
        exportBackupElement.setAttribute("persisted", Boolean.toString(persisted) );
    }
    
    public String getToFile(){
        String saveToFile=toFile;
        if (appendTimestamp)
            saveToFile = FilePathUtils.appendTimestamp(saveToFile);

        return saveToFile;
    }
    
    
    public void setAppendTimestamp(boolean appendTimestamp) {
        this.appendTimestamp = appendTimestamp;
    }

    public ExportImportFileType getFormat() {
        return format;
    }
    
    private Element createExportBackupElement( String somaOperation ){
        exportBackupElement = new Element(somaOperation, DPConst.DP_NS);

        getRequestElement().addContent(exportBackupElement);
        
        return exportBackupElement;
    }
    
    public Element getOperationElement() {
        return exportBackupElement;
    }
        
}
