package com.myarch.dpbuddy.filemanagement;

import org.jdom2.Document;
import org.jdom2.Element;

import com.myarch.dpbuddy.BaseRequest;
import com.myarch.dpbuddy.DPCommand;
import com.myarch.dpbuddy.DPConst;
import com.myarch.dpbuddy.Device;

public class GetFileStoreInfoCommand implements DPCommand<FileStoreInfoResponse> {
    
//    private Log logger = LogFactory.getLog(getClass());
    
    
    private BaseRequest getFileStoreRequest=new BaseRequest();
    
    public GetFileStoreInfoCommand(String fileStore) {
        Element getFileStoreElt=createGetFileStoreElement(fileStore);
        getFileStoreRequest.getRequestElement().addContent( getFileStoreElt );
    }
    
    public GetFileStoreInfoCommand() {
        this(null);
    }
    
    
    
    /*
     *     <dp:get-filestore location="local:" annotated="false" layout-only="false" no-subdirectories="false" />
     */
    private Element createGetFileStoreElement(String fileStore){
        
        Element getFileStoreElt=new Element("get-filestore", DPConst.DP_NS);
        getFileStoreElt.setAttribute("annotated", "false");
        getFileStoreElt.setAttribute("layout-only", "false");
        getFileStoreElt.setAttribute("no-subdirectories", "false");
       
        if (fileStore!=null)
            getFileStoreElt.setAttribute("location", fileStore);
        
        return getFileStoreElt;
    }
    
    public FileStoreInfoResponse execute( Device device ) {
        Document responseDoc=device.executeRequest(getFileStoreRequest);
        FileStoreInfoResponse response = new FileStoreInfoResponse( responseDoc );
        return response;
    }

}
