package com.myarch.dpbuddy.filemanagement;

import java.util.HashMap;
import java.util.Map;

import com.myarch.dpbuddy.DPBuddyException;
import com.myarch.dpbuddy.Device;
import com.myarch.dpbuddy.ResultResponse;
import com.myarch.dpbuddy.action.ActionCommand;

/**
 * Removes a directory in a DataPower filesystem. 
 */
public class RmdirCommand extends ActionCommand {
    
    public final static String ACTION_NAME="RemoveDir";
    
    private Map<String, Object> currentDirs = new HashMap<String,Object>();
    
    public void addDir( String dir ){
        createDeleteDirElement(Device.prependDefaultFileStore(dir));
    }
    

    private void createDeleteDirElement( String dir ){
        // make sure that this directory has not been added before
        if ( currentDirs.containsKey(dir) )
            return;
        addAction(ACTION_NAME, "Dir", dir);
        currentDirs.put(dir, null);
    }    
    
    @Override
    public ResultResponse execute( Device device ) {
        if ( getActionElements().size()==0)
            throw new DPBuddyException("You must provide at least one directory to remove");

    	return super.execute(device);
    }
    
}
