package com.myarch.dpbuddy.filemanagement.ant;


import org.apache.tools.ant.BuildException;
import org.kohsuke.args4j.Option;

import com.myarch.dpbuddy.ant.BaseDPBuddyTask;
import com.myarch.dpbuddy.filemanagement.DownloadFileCommand;

/**
 * Downloads a single file from DataPower.
 * downloadFile file= to=
 */
public class DownloadFileTask extends BaseDPBuddyTask{
    
    private String file;
    private String destination;
   
    @Option(name="-file", required=true, usage="Absolute path to the file on the device.")
    public void setFile( String file ) {
        this.file = file;
    }

    @Option(name="-to", required=true, usage="Local directory or file name where the remote file will be saved.")
    public void setTo( String destination ) {
        this.destination = destination;
    }

    @Override
    public void executeDPTask() throws BuildException {
        validator.validateRequired(file, "file", 
                    "Path to the file to download");
        validator.validateRequired(destination, "to", 
                "File or directory to download the file to");
        validator.throwIfErrors();
        
        DownloadFileCommand getFileCommand=new DownloadFileCommand();
        getFileCommand.setFromFile(file);
        getFileCommand.setToFile(destination);

        executeRequest( getFileCommand );
        logger.info(String.format("Saved file '%s' to '%s'",file, destination));
    }
    
}
