package com.myarch.dpbuddy.filemanagement.ant;

import java.util.HashSet;
import java.util.Set;

import org.apache.tools.ant.BuildException;
import org.kohsuke.args4j.Option;

import com.myarch.dpbuddy.ant.BaseDPBuddyTask;
import com.myarch.dpbuddy.filemanagement.MkdirCommand;

/**
 * Creates a directory tree on the device
 */
public class MkdirTask extends BaseDPBuddyTask {

    private String dir;

    private Set<Dir> dirList=new HashSet<Dir>();

    @Option(name="-dir", required=true, usage="A directory or a path to create")
    public void setDir( String dir ) {
        this.dir=dir;
    }

    public void addConfiguredDir( Dir dir ) {
        dirList.add( dir );
    }

    @Override
    public void executeDPTask() throws BuildException {

        MkdirCommand createDirCommand=new MkdirCommand();
        if (dir != null)
            createDirCommand.addDir( dir );
        for (Dir dir : dirList) {
            createDirCommand.addDir( dir.getPath() );
        }

        executeRequest( createDirCommand );
    }

    public static class Dir {
        String path;

        public String getPath() {
            return path;
        }

        public void setPath( String path ) {
            this.path=path;
        }
    }

}
