package com.myarch.dpbuddy.filemanagement.ant;

import org.apache.tools.ant.BuildException;
import org.kohsuke.args4j.Option;

import com.myarch.dpbuddy.ant.BaseDPBuddyTask;
import com.myarch.dpbuddy.filemanagement.RemoteCopyCommand;

/**
 * Copies remote file to the device, used for firmware upgrades
 */
public class RemoteCopyAntTask extends BaseDPBuddyTask {

    private String fromUrl;

    @Option(name="-fromUrl",
                    usage="URL of the source file. http and https protocols are supported. Can also be the path local to DataPower.")
    public void setCommand( String fromUrl ) {
        this.fromUrl=fromUrl;
    }

    private String dpFile="";

    @Option(name="-dpFile",
                    usage="Absolute path to the file on DataPower. The file will be downloaded from the 'fromURL' and saved as this file. Defaults to 'local://<filename from the source url>'. You can also provide only the filestore path, e.g., 'local:/'")
    public void setDpFile( String file ) {
        this.dpFile=file;
    }

    private boolean force=true;

    @Option(name="-force", aliases="-f", usage="Override the target file if exists. Defaults to 'true'.")
    public void setForce( boolean force ) {
        this.force=force;
    }

    private String xmlManager;

    @Option(name="-xmlManager",
                    usage="Name of the XML manager to use for copy from HTTPS: URLs. If not provided, DPBuddy will create its own, named 'dpbuddy-copy'")
    public void setXmlManager( String xmlManager ) {
        this.xmlManager=xmlManager;
    }

    // XMLManager -- if not provided, dpbuddy creates its own

    // Automatically create dir? Parameter -createDir

    // TODO: unit test

    @Override
    public void executeDPTask() throws BuildException {
        // TODO: validation
        
        RemoteCopyCommand remoteCopy=new RemoteCopyCommand();
        remoteCopy.execute( getDevice(), fromUrl, dpFile, force, xmlManager );
    }


}
