package com.myarch.dpbuddy.filemanagement.ant;

import java.util.HashSet;
import java.util.Set;

import org.apache.tools.ant.BuildException;
import org.kohsuke.args4j.Option;
import org.kohsuke.args4j.spi.ExplicitBooleanOptionHandler;

import com.myarch.dpbuddy.ant.BaseDPBuddyTask;
import com.myarch.dpbuddy.filemanagement.RmdirCommand;
import com.myarch.dpbuddy.filemanagement.ant.MkdirTask.Dir;

/**
 * Removes the directory from the device
 */
public class RmdirTask extends BaseDPBuddyTask {

    private String dir;

    private Boolean failOnError;

    private Set<Dir> dirList=new HashSet<Dir>();
    
    @Option(name="-dir", required=true, usage="A directory or a path to delete")
    public void setDir( String dir ) {
        this.dir=dir;
    }

    public void addConfiguredDir( Dir dir ) {
        dirList.add( dir );
    }
    
    @Option(name="-failOnError", handler=ExplicitBooleanOptionHandler.class, usage="Fail if the directory doesn't exist.")
    public void setFailOnError( Boolean failOnError ) {
        this.failOnError=failOnError;
    }

    @Override
    public void executeDPTask() throws BuildException {
        RmdirCommand removeDirCommand=new RmdirCommand();

        if (dir != null)
            removeDirCommand.addDir( dir );

        for (Dir dir : dirList) {
            removeDirCommand.addDir( dir.getPath() );
        }

        if (failOnError != null) {
            removeDirCommand.setIgnoreErrors( !failOnError );
        }

        executeRequest( removeDirCommand );

    }

}
