package com.myarch.dpbuddy.inpututil;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;

import org.apache.commons.io.FileUtils;

import com.myarch.dpbuddy.DPBuddyException;

public class InputFileWrapper implements Input{
    
    private File file;
    private FileInputStream fileInputStream=null;
    
    
    public InputFileWrapper(File file) {
        this.file=file;
        fileInputStream=open(file);
    }
    
    public void reopen() {
        fileInputStream=open(file);
    }
    
    public InputFileWrapper(String filePath) {
        this( new File(filePath) );
    }
    
    public File getFile() {
        return file;
    }

    private FileInputStream open(File file) {
        try {
            return FileUtils.openInputStream(file);
        } catch (IOException e) {
            throw new DPBuddyException(e);
        }
    }
    
    public void close(){
        try {
            fileInputStream.close();
        } catch (IOException e) {
            throw new DPBuddyException(e);
        }
    }

    public String getName() {
        return file.getAbsolutePath();
    }

    public InputStream getInputStream() {
        return fileInputStream;
    }
    

}
