package com.myarch.dpbuddy.inpututil;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;

import org.apache.commons.io.IOUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.filters.StringInputStream;

import com.myarch.dpbuddy.DPBuddyException;

public class InputStringWrapper implements Input{
    private Log logger = LogFactory.getLog(this.getClass());
    
    private String content;
    private String name;
    
    public InputStringWrapper(String s, String name) {
        this.content=s;
        this.name=name;
    }
    
    public InputStringWrapper(File file) {
        try {
            content=IOUtils.toString(new FileReader(file));
        }
        catch (FileNotFoundException e) {
            throw new DPBuddyException( e );
        }
        catch (IOException e) {
            throw new DPBuddyException( e );
        }
        
        name=file.getName();
    }
    
    public String getName() {
        return name;
    }

    public InputStream getInputStream() {
        return new StringInputStream(content);
    }
    
    
    public void resolveVars(Project project) {
        content=project.replaceProperties( content );
        logger.debug( String.format( "Content of '%s' after resolving properties:\n%s", name, content ) );
        if ( content.contains("${") )
            throw new DPBuddyException("'%s' contains an unresolved property. Please make sure that all properties are defined.", name);
    }
    

}
