package com.myarch.dpbuddy.log;

import java.util.regex.Pattern;

import com.myarch.dpbuddy.DPObject;

public class DPObjectLogFilter implements LogFilter {
    // private Log logger = LogFactory.getLog(getClass());

    private String dpClass;
    private String dpObject;

    private boolean isErrorOnly=false;
    
    /**
     * @param dpClass
     * @param dpObject
     */
    public DPObjectLogFilter(String dpClass, String dpObject) {
        super();
        this.dpClass=dpClass;
        this.dpObject=dpObject;
    }

    public DPObjectLogFilter(DPObject dpObject) {
        this( dpObject.getClazz(), dpObject.getName() );
    }

    public DPObjectLogFilter() {
        super();
    }

    
    public void setErrorOnly( boolean isErrorOnly ) {
        this.isErrorOnly=isErrorOnly;
    }

    public String getClazz() {
        return dpClass;
    }

    public void setClass( String dpClass ) {
        this.dpClass=dpClass;
    }

    public String getObject() {
        return dpObject;
    }

    public void setObject( String dpObject ) {
        this.dpObject=dpObject;
    }

    public boolean matches( LogEntry logEntry ) {
        if (isErrorOnly && !logEntry.isError())
            return false;
        
        boolean classMatches=true;
        if (dpClass != null) {
            String logEntryDPClass=logEntry.getDPClass();
            Pattern pattern=Pattern.compile( dpClass );
            classMatches=( logEntryDPClass != null && pattern.matcher( logEntryDPClass ).find() );
        }

        boolean objectMatches=true;
        if (dpObject != null) {
            String logEntryDPObject=logEntry.getObject();
            Pattern pattern=Pattern.compile( dpObject );
            objectMatches=( logEntryDPObject != null && pattern.matcher( logEntryDPObject ).find() );
        }

        return classMatches && objectMatches;

    }

}
