package com.myarch.dpbuddy.log;

import org.apache.commons.lang.StringUtils;

import com.google.gson.JsonObject;

public class ExtLatencyParser {
    //ExtLatency: TS=0,HR=0,PS=0,PC=1,BS=1, == HR=1,BS=1,TC=1, [http://dp7-local:3056/]\n";
    // dp.latency.request{TS, 
    public JsonObject parseLatencyMessage(String message) {
        JsonObject latencyRecord=new JsonObject();
        String[] latencyRequestResponseTokens=StringUtils.splitByWholeSeparator( message, "==" );
        if (latencyRequestResponseTokens.length>0) {
            latencyRecord.add( "request", parseRequestOrResponse(latencyRequestResponseTokens[0]) );
        }
        if (latencyRequestResponseTokens.length>1) {
            latencyRecord.add( "response", parseRequestOrResponse(latencyRequestResponseTokens[1]) );
        }
        
        return latencyRecord;
    }
    
    private JsonObject parseRequestOrResponse(String requestOrResponseLatencyMessage) {

        JsonObject latencyRequestReponseRec=new JsonObject();
        String[] latencyItems=StringUtils.splitByWholeSeparator( requestOrResponseLatencyMessage, "," );
        for(String latencyItemToken:latencyItems){
            LatencyItem latencyItem=parseLatencyItem(latencyItemToken);
            if (latencyItem!=null) {
                latencyRequestReponseRec.addProperty( latencyItem.name, latencyItem.value );
            }
        }
        
        return latencyRequestReponseRec;
    }
    
    private LatencyItem parseLatencyItem(String latencyExpressionStr) {
        String[] nameValTokens=StringUtils.splitByWholeSeparator(latencyExpressionStr, "=");
        if (nameValTokens.length!=2) {
            return null;
        }
        
        LatencyItem latencyItem=new LatencyItem();
        latencyItem.name=sanitizeName(nameValTokens[0].trim());
        latencyItem.value=-1;
        try {
            latencyItem.value=Integer.parseInt( nameValTokens[1].trim() );
        }
        catch (NumberFormatException nfe) {
        }
        
        return latencyItem;
    }
    
    private String sanitizeName(String name) {
        String[] nameTokens=StringUtils.split( name, " :=");
        return nameTokens[nameTokens.length-1];
    }
    
    private class LatencyItem {
        public String name;
        public int value;
        
    }

}
