package com.myarch.dpbuddy.log;

import org.apache.tools.ant.BuildException;
import org.kohsuke.args4j.Option;

import com.myarch.dpbuddy.ant.BaseDPBuddyTask;

/**
 * Logs the message on the device
 * 
 */
public class LogAntTask extends BaseDPBuddyTask {

    private String level=DPLogLevel.WARN.toString();
    private String message="";
    private String category=LogMessageCommand.DEFAULT_LOG_CATEGORY;

    @Option(name="-level", usage="Log entry's severity level, one of the following: EMERG, ALERT, CRITIC, ERROR, WARN, NOTICE, INFO, DEBUG. Defaults to WARN.")
    public void setLevel( String level ) {
        this.level=level;
    }

    @Option(name="-message", required=true,
                    usage="Message to log.")
    public void setMessage( String message ) {
        this.message=message;
    }

    @Option(
                    name="-category",
                    usage="DataPower log category. You can find the list of all categories under Administration/Miscellaneous/Configure Log Category in WebGUI. Defaults to 'all'.")
    public void setCategory( String category ) {
        this.category=category;
    }

    public void addText( String msg ) {
        message+=getProject().replaceProperties( msg );
    }

    @Override
    public void executeDPTask() throws BuildException {
        LogMessageCommand logMessageCommand=new LogMessageCommand( DPLogLevel.fromString( level ),
                        message, category );
        executeRequest( logMessageCommand );
        logger.debug( "Logged message " + message + " on the device with the level " + level );
    }

}
