package com.myarch.dpbuddy.log;

import com.myarch.dpbuddy.action.ActionCommand;

public class LogMessageCommand extends ActionCommand {
    
    public final static String DEFAULT_LOG_CATEGORY="all";
    public final static String SEND_LOG_EVENT_ACTION="SendLogEvent";
    
    private String category=DEFAULT_LOG_CATEGORY;
    
    public LogMessageCommand(DPLogLevel level, String message) {
        super(SEND_LOG_EVENT_ACTION);
        
        addActionChildElement("LogType", category);
        addActionChildElement("GenLogLevel", level.toString().toLowerCase());
        addActionChildElement("LogEvent", message);
    }

    
    public LogMessageCommand(DPLogLevel level, String message, String category) {
        this( level, message );
        this.category=category;
    }


}
