package com.myarch.dpbuddy.log;


import java.util.ArrayList;
import java.util.List;

import org.jdom2.Document;
import org.jdom2.Element;

import com.myarch.dpbuddy.BaseResponse;

public class LogResponse extends BaseResponse {
    
    public LogResponse( Document doc ) {
        super(doc);
    }
    
    
    public void validate() {
        getRequiredResponseElements("dp:log");
    }

    public List<LogEntry> getLogEntries() {
    	return getLogEntries(LogEntry.DEFAULT_LOG_FORMAT);
    	
    }
    
    public List<LogEntry> getLogEntries(String logFormat) {
        List<LogEntry> logEntries = new ArrayList<LogEntry>();
        List<Element> entryElts = getResponseElements("log-entry");
        for( Element entryElt:entryElts){
            LogEntry entry = new LogEntry( entryElt, logFormat );
            logEntries.add( entry );
        }
        
        return logEntries;
    }

}

