package com.myarch.dpbuddy.logtarget;

import org.apache.tools.ant.BuildException;
import org.kohsuke.args4j.Option;

import com.myarch.dpbuddy.Device;
import com.myarch.dpbuddy.config.DPConfiguration;

public class FileLogTargetAntTask extends LogTargetBaseTask {

    public final static String TEMPLATE_RESOURCE="/com/myarch/dpbuddy/dpconfig/file-logtarget.xml";

    private String fileName;
    //May be make it parameter in the future
    private final static String ARCHIVE_MODE="rotate";
    
    private int logSize=512;
    private int numberOfRotations=3;
    

    @Option(name="-fileName", required=true, usage="Destination configuration: file name")
    public void setFileName( String fileName ) {
        this.fileName=fileName;
    }

    @Option(name="-numberOfRotations", aliases="-rotations", usage="Number of rotations, defaults to 3.")
    public void setNumberOfRotations( int numberOfRotations ) {
        this.numberOfRotations=numberOfRotations;
    }

    @Option(name="-logSize", usage="Log size in KB, defaults to 4096 KB.")
    public void setLogSize( int logSize ) {
        this.logSize=logSize;
    }
    
    @Override
    public void executeDPTask() throws BuildException {
        DPConfiguration dpConfigOfLogTarget = prepTargetConfig(TEMPLATE_RESOURCE);
        
        dpConfigOfLogTarget.setOrAddElement( "LocalFile", Device.prependFileStore( "logstore", fileName ));
        dpConfigOfLogTarget.setOrAddElement( "Rotate", str(numberOfRotations) );
        dpConfigOfLogTarget.setOrAddElement( "ArchiveMode", ARCHIVE_MODE);
        dpConfigOfLogTarget.setOrAddElement( "Size", str(logSize) );
        
        executeImport(dpConfigOfLogTarget);
    }
    
}
