package com.myarch.dpbuddy.logtarget;

import java.util.ArrayList;
import java.util.List;

import org.apache.commons.lang3.tuple.Pair;
import org.jdom2.Element;

import com.myarch.hocon.HoconUtils;
import com.typesafe.config.Config;

public class LogTargetEvent {
    
    private String category;
    private String level;
    
    public LogTargetEvent(String category, String level) {
        super();
        this.category=category;
        this.level=level;
    }
    
    public LogTargetEvent(Pair<String, String> pair) {
        this(pair.getLeft(),pair.getRight());
    }

    
    
    public String category() {
        return category;
    }
    public String level() {
        return level;
    }
 
    /*
    <LogEvents>
        <Class class="LogLabel">all</Class>
        <Priority>info</Priority>
    </LogEvents>

     */    
    
    public Element toXmlElement() {
        Element rootElt=new Element("LogEvents");
        
        Element classElt=new Element("Class");
        classElt.setAttribute( "class", "LogLabel" );
        classElt.setText( category );
        
        rootElt.addContent( classElt );
        
        Element priorityElt=new Element("Priority");
        priorityElt.setText( level );
        rootElt.addContent( priorityElt );
        
        return rootElt;
    }
    

    public static List<LogTargetEvent> fromConfig(Config config) {

        List<LogTargetEvent> logTargetEvents = new ArrayList<>();
        List<Pair<String, String>> nameValues=HoconUtils.configToNameStringValueList(config);
        for (Pair<String, String> nameValue:nameValues) {
            logTargetEvents.add( new LogTargetEvent(nameValue) );
        }
        
        return logTargetEvents;
    }
    

}
