package com.myarch.dpbuddy.logtarget;

import org.apache.tools.ant.BuildException;
import org.kohsuke.args4j.Option;

import com.myarch.dpbuddy.action.ActionCommand;
import com.myarch.dpbuddy.ant.BaseDPBuddyTask;
import com.myarch.dpbuddy.log.DPLogLevel;

/**
 * Set log level on the device
 * 
 */
public class SetLogLevelAntTask extends BaseDPBuddyTask {

    private String levelStr;
    @Option(name="-level", required=true, usage="Log entry's severity level, one of the following: EMERG, ALERT, CRITIC, ERROR, WARN, NOTICE, INFO, DEBUG.")
    public void setLevel( String level ) {
        this.levelStr=level;
    }

    @Override
    public void executeDPTask() throws BuildException {
        DPLogLevel level=DPLogLevel.fromString( levelStr );
        ActionCommand actionCommand=new ActionCommand();

        actionCommand.addAction( "SetLogLevel", "LogLevel", level.toString().toLowerCase() );

        executeRequest( actionCommand );
    }

}
