package com.myarch.dpbuddy.logtarget;

import org.apache.tools.ant.BuildException;
import org.kohsuke.args4j.Option;

import com.myarch.dpbuddy.config.DPConfiguration;

public class SoapLogTargetAntTask extends LogTargetBaseTask {

    public final static String TEMPLATE_RESOURCE="/com/myarch/dpbuddy/dpconfig/http-logtarget.xml";

    private String url;
    
    @Option(name="-remoteUrl", required=true,  usage="Destination configuration: url")
    public void setRemoteUrl( String url ) {
        this.url=url;
    }
    
    private String localIpAddress;
    @Option(name="-localAddress", usage="Local address (host alias)")
    public void setLocalAddress( String localIpAddress ) {
        this.localIpAddress=localIpAddress;
    }    

    
    @Override
    public void executeDPTask() throws BuildException {
        DPConfiguration dpConfigOfLogTarget = prepTargetConfig(TEMPLATE_RESOURCE);
        
        dpConfigOfLogTarget.setOrAddElement( "URL", url);
        if (localIpAddress!=null) {
            dpConfigOfLogTarget.setOrAddElement( "LocalAddress", localIpAddress );
        }
        
        executeImport(dpConfigOfLogTarget);
    }
    
}
