package com.myarch.dpbuddy.logtarget;

import org.apache.tools.ant.BuildException;
import org.kohsuke.args4j.Option;

import com.myarch.dpbuddy.config.DPConfiguration;

public class SyslogLogTargetAntTask extends LogTargetBaseTask{

    public final static String TEMPLATE_RESOURCE="/com/myarch/dpbuddy/dpconfig/syslog-logtarget.xml";

    private String remoteHost;
    private int remotePort=514;
    

    @Option(name="-remotePort", usage="Syslog server's port, defaults to 514")
    public void setRemotePort( int remotePort ) {
        this.remotePort=remotePort;
    }

    @Option(name="-remoteHost", required=true,  usage="Syslog server's host")
    public void setRemoteHost( String remoteHost ) {
        this.remoteHost=remoteHost;
    }


    private String localIdentifier;
    @Option(name="-localIdentifier", usage="Local identifier for syslog")
    public void setLocalIdentifier( String localIdentifier ) {
        this.localIdentifier=localIdentifier;
    }

    
    private String localIpAddress;
    @Option(name="-localAddress", usage="Local address (host alias)")
    public void setLocalAddress( String localIpAddress ) {
        this.localIpAddress=localIpAddress;
    }    
    
    @Override
    public void executeDPTask() throws BuildException {
        DPConfiguration dpConfigOfLogTarget = prepTargetConfig(TEMPLATE_RESOURCE);
        dpConfigOfLogTarget.setOrAddElement( "RemoteAddress", remoteHost );
        dpConfigOfLogTarget.setOrAddElement( "RemotePort", new Integer( remotePort ).toString() );
        if (localIpAddress!=null) {
            dpConfigOfLogTarget.setOrAddElement( "LocalAddress", localIpAddress );
        }
        if (localIdentifier!=null) {
            dpConfigOfLogTarget.setOrAddElement( "LocalIdentifier", localIdentifier );
        }
        
        executeImport(dpConfigOfLogTarget);
    }
    
}
