package com.myarch.dpbuddy.quiesce;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.myarch.dpbuddy.status.OperationalState;

public enum QuiesceAction {
    QUIESCE("Quiesce", OperationalState.DOWN, "quiesced", 180, true), 
    UNQUIESCE("Unquiesce", OperationalState.UP, "unquiesced", 90, false);

    private final Log logger = LogFactory.getLog(getClass());
    
    private String actionName;
    private OperationalState targetOpState;
    private String verbMessage;
    private int minTimeout;
    private boolean passTimeoutToDP;
    
    /**
     * @param actionName
     * @param targetOpState
     */
    private QuiesceAction(String actionName, OperationalState targetOpState, String verbMessage, int minTimeout, boolean passTimeoutToDP) {
        this.actionName = actionName;
        this.targetOpState = targetOpState;
        this.verbMessage = verbMessage;
        this.minTimeout=minTimeout;
        this.passTimeoutToDP=passTimeoutToDP;
    }

    public String getActionName() {
        return actionName;
    }

    public OperationalState getTargetOpState() {
        return targetOpState;
    }
    
    public String getVerbMessage() {
        return verbMessage;
    }
    
    public int getMinTimeout() {
        return minTimeout;
    }
    
    public boolean isPassTimeoutToDP(){
        return passTimeoutToDP;
    }
    
    public String toString() {
        return actionName;
    }
    
    
    public int validateTimeout( Integer timeout ){
        if (timeout==null) {
            timeout=this.getMinTimeout();
            logger.debug(String.format("Timeout was not provided. Setting it to the default value %d", timeout));
        }

//        if (timeout<getMinTimeout() && timeout>=0)
//            throw new DPBuddyException("%s timeout must be at least %d seconds", this, getMinTimeout());
        
        return timeout;
        
    }

}
