package com.myarch.dpbuddy.quiesce;

import org.apache.tools.ant.BuildException;
import org.kohsuke.args4j.Option;

import com.myarch.dpbuddy.ant.BaseDPBuddyTask;

public class QuiesceDomainAntTask extends BaseDPBuddyTask {
    
    private Integer timeout;
    
    @Option(name="-timeout",
                    usage="Time, in seconds, to wait for the domain to reach the desired operational state.")
    public void setTimeout(Integer timeout) {
        this.timeout = timeout;
    }
    
    
    private String domainPatternsStr;
    
    @Option(
                    name="-domainPatterns",
                    aliases="-domains",
                    usage="Comma-delimited list of regular expression patterns defining what domains to quiesce/un-quiesce.")
    public void setDomainPatterns( String domainPatterns ) {
        this.domainPatternsStr=domainPatterns;
    }
    
    @Override
    public void executeDPTask() throws BuildException {
        QuiesceAction quiesceAction=QuiesceAction.QUIESCE;
        if (getTaskName().toLowerCase().contains(QuiesceAction.UNQUIESCE.toString().toLowerCase()))
            quiesceAction=QuiesceAction.UNQUIESCE;
        
        QuiesceUnquiesceDomainCommand quiesceCommand=new QuiesceUnquiesceDomainCommand(quiesceAction, domainPatternsStr, timeout);
        executeRequest( quiesceCommand );
    }
    
    @Override
    protected boolean isDefaultDomainOverride(){
        return true;
    }

}
