package com.myarch.dpbuddy.restart;

import org.apache.tools.ant.BuildException;
import org.kohsuke.args4j.Option;

import com.myarch.dpbuddy.ant.BaseDPBuddyTask;
import com.myarch.dpbuddy.cli.BoolOptionHandler;

public class RestartDPAntTask extends BaseDPBuddyTask {

    private int timeout=RestartDPService.DEFAULT_TIMEOUT;
    private String mode=RestartDPService.DEFAULT_RESTART_MODE;
    private boolean isQuiesce=false;
    
    @Option(name="-timeout",
                    usage="Time, in seconds, to wait for DataPower to become available after restart. -1 disables waiting. Defaults to "
                        + RestartDPService.DEFAULT_TIMEOUT + " seconds.")
    public void setTimeout( int timeout ) {
        this.timeout=timeout;
    }

    @Option(name="-mode", usage="reload, reboot or halt. 'reload' is the default.")
    public void setMode( String mode ) {
        this.mode=mode;
    }

    
    @Option(name="-quiesce", handler=BoolOptionHandler.class,
                    usage="Quiesce all domains before the restart.")
    public void setQuiesce( boolean quiesce ) {
        this.isQuiesce=quiesce;
    }

    
    @Override
    public void executeDPTask() throws BuildException {
        RestartDPService restartService=new RestartDPService();
        restartService.performRestart( getDevice(), mode, timeout, isQuiesce );
    }
    
    @Override
    protected boolean isDefaultDomainOverride(){
        return true;
    }

}
