package com.myarch.dpbuddy.status;

import org.apache.tools.ant.BuildException;
import org.kohsuke.args4j.Option;

import com.myarch.dpbuddy.Device;
import com.myarch.dpbuddy.ant.BaseDPBuddyTask;

public class AssertOpenPortsAntTask extends BaseDPBuddyTask {

    private String ports;

    @Override
    public void executeDPTask() throws BuildException {
        validator.validateRequired( ports, "ports", "List of ports to check" );
        validator.throwIfErrors();
        
        assertPorts( getDevice(),  ports );

        logger.info( String.format( "Port(s) %s is open on the device", ports.trim() ) );
    }

    @Option(name="-ports", required=true, usage="Comma-delimited list of ports to check.")
    public void setPorts( String ports ) {
        this.ports=ports;
    }

    public static void assertPorts( Device device, String ports ) {
        
        ServiceStatusCommand serviceStatusCommand=new ServiceStatusCommand();
        ServiceStatusResponse serviceStatusResponse=serviceStatusCommand.execute( device );
        serviceStatusResponse.validatePorts( ports );
    }
}
