package com.myarch.dpbuddy.status;

import org.apache.tools.ant.BuildException;
import org.kohsuke.args4j.Option;

import com.myarch.dpbuddy.ant.BaseDPBuddyTask;

public class AssertStatusAntTask extends BaseDPBuddyTask {

    private String clazz;
    private String expression;

    @Option(name="-class", required=true, usage="Status 'class' as defined in xml-mgmt.xsd.")
    public void setClass( String clazz ) {
        this.clazz=clazz;
    }

    @Option(name="-expression", required=true,
                    usage="A Groovy Boolean expression (has to return true or false).")
    public void setExpression( String expression ) {
        this.expression=expression;
    }

    @Override
    public void executeDPTask() throws BuildException {

        validator.validateRequired( clazz, "class", "Status class" );
        validator.validateRequired( expression, "expression", "Expression to verify status" );

        validator.throwIfErrors();

        AssertStatusCommand assertStatusCommand=new AssertStatusCommand( clazz, expression );

        assertStatusCommand.execute( getDevice() );
    }

}
