package com.myarch.dpbuddy.status;

import com.myarch.dpbuddy.DPBuddyException;

public enum OperationalState {
    UP("up"), DOWN("down");
    
    private String opStateString;

    /**
     * @param opStateString
     */
    private OperationalState(String opStateString) {
        this.opStateString = opStateString;
    }

    /**
     * 
     * @return opState as used by DataPower in the logs and in the status response, e.g., Up, Down.
     */
    public String getOpStateString() {
        return opStateString;
    }
    
    public static OperationalState fromString( String opStateString ){
        if (opStateString == null ) return null;
        
        opStateString=opStateString.toUpperCase();
        for( OperationalState opStateInstance: OperationalState.values() ) {
            if ( opStateString.equals(opStateInstance.toString()) ){
                return opStateInstance;
            }
        }
        throw new DPBuddyException("You must provide UP or DOWN values for the OpState. You provided: "+opStateString);
    }


}
