package com.myarch.dpbuddy.status;

import org.jdom2.Element;

import com.myarch.dpbuddy.DPObject;

public class ServiceStatus extends DPObject {

    private String port;
    private String ip;
    
    public ServiceStatus(String clazz, String name) {
        super( clazz, name );
    }

    public ServiceStatus(DPObject dpObject) {
        super( dpObject );
    }

    public ServiceStatus(Element statusElement) {
        super( statusElement.getChildText( "ServiceClass" ), statusElement.getChildText( "ServiceName" ) );
        port=statusElement.getChildText( "LocalPort" );
        ip=statusElement.getChildText( "LocalIP" );
    }

    public String getPort() {
        return port;
    }
    

    public String getIp() {
        return ip;
    }

    public String toStatusString() {
        String s=super.toClassObjectStr();
        s+="--" + getPort();

        return s;
    }
    
    public boolean equalsDPObject(DPObject dpObj) {
        return getClazz().equals( dpObj.getClazz() ) && getName().equals( dpObj.getName() ); 
    }
    
    public boolean portEquals(String port) {
        int portToCompareWith=Integer.parseInt( port );
        int thisPort=Integer.parseInt( this.port );
        
        return (portToCompareWith==thisPort);
    }

    public boolean equals( Object obj ) {
        if (this == obj)
            return true;
        if (!( obj instanceof ServiceStatus ))
            return false;

        ServiceStatus otherDPObject=(ServiceStatus) obj;

        return super.equals( otherDPObject ) && port.equals( otherDPObject.port ) && ip.equals( otherDPObject.ip );
    }
    
    

    public int hashCode() {
        int hash=1;
        hash=hash * 31 + super.hashCode();
        hash=hash * 31 + port.hashCode();
        hash=hash * 31 + ip.hashCode();

        return hash;
    }

}
