package com.myarch.dpbuddy.status;

import org.apache.tools.ant.BuildException;
import org.kohsuke.args4j.Option;

import com.myarch.dpbuddy.ant.BaseDPBuddyTask;

public class ServiceStatusAntTask extends BaseDPBuddyTask {

    private String domainPatternsString;

    @Option(name="-domainPatterns", aliases="-domains",
                    usage="Comma-delimited list of regular expression patterns defining what domains to query.")
    public void setDomainPatterns( String domainPatterns ) {
        this.domainPatternsString=domainPatterns;
    }

    @Override
    public void executeDPTask() throws BuildException {
        ServiceStatusCommand serviceStatusCommand=new ServiceStatusCommand();
        if (domainPatternsString != null) {
            serviceStatusCommand.executeForDomainPatterns( getDevice(), domainPatternsString );
        }
        else {
            serviceStatusCommand.execute( getDevice() );
        }
    }
    
    @Override
    protected boolean isSuppressDomainLogging() {
        return true;
    }

}
