package com.myarch.dpbuddy.status;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class ServiceStatusReport {
    // domain, class, name, port
    public final static int NAME_LENGTH=25;
    public final static int PORT_LENGTH=7;

    public final static String FORMAT="%-10.9s%-20.19s%-25.24s%-25.24s%-7s";
    public final static List<String> HEADERS= Arrays.asList( "Device", "Domain","Type (class)", "Name", "Port");
    
    public final static int TOTAL_LENGTH=10+20+NAME_LENGTH*2+PORT_LENGTH;

    public static String genHeader() {
        return TabularReport.genHeader( HEADERS, FORMAT, TOTAL_LENGTH);
    }    
    
    public static String genRows(String deviceName, String domain, ServiceStatusResponse serviceStatusResponse) {
        Iterable<ServiceStatus> serviceStatuses=serviceStatusResponse.getServiceStatuses();
        List<List<Object>> data=new ArrayList<>();
        for(ServiceStatus serviceStatus:serviceStatuses) {
            List<Object> row=new ArrayList<>();
            row.add( deviceName );
            row.add(domain );
            row.add(serviceStatus.getClazz() );
            row.add(serviceStatus.getName() );
            row.add(serviceStatus.getPort() );
            
            data.add( row );
        }

        return TabularReport.genRows( data, FORMAT);      
        
    }
    
}
