package com.myarch.dpbuddy.status;

import org.jdom2.Document;

import com.myarch.dpbuddy.DPCommand;
import com.myarch.dpbuddy.Device;

public class StatusCommand implements DPCommand<StatusResponse> { 
    
    public final static StatusCommand VERSION_STATUS_COMMAND=new StatusCommand("Version");
    
    private String clazz;
    
    private StatusRequest request;
    
    public StatusCommand( String clazz ) {
        super();
        request=new StatusRequest(clazz);
        this.clazz = clazz;
    }

    public StatusResponse execute( Device device ) {
        return execute( device, device.getCurrentDomain() ); 
    }
    
    public StatusResponse execute( Device device, String domain ) {
        
        Document responseDoc = device.executeRequest( domain, request );
        StatusResponse dpResponse = new StatusResponse(clazz, responseDoc );
        
        return dpResponse;
    }
    
}
