package com.myarch.dpbuddy.status;

import java.util.List;

import org.apache.commons.lang3.StringUtils;

public class TabularReport {

    public static String genHeader( List<String> headers, String headerFormat, int length ) {

        StringBuilder reportBuf=new StringBuilder();
        String header=String.format( headerFormat, headers.toArray() );

        reportBuf.append( header );
        reportBuf.append( "\n" );
        reportBuf.append( StringUtils.repeat( "-", length + 1 ) );
        reportBuf.append( "\n" );

        return reportBuf.toString();
    }

    public static String genRows( List<List<Object>> data, String dataFormat ) {
        StringBuilder reportBuf=new StringBuilder();

        for (List<Object> row : data) {
            String formattedRow=String.format( dataFormat, row.toArray() );
            reportBuf.append( formattedRow );
            reportBuf.append( "\n" );
        }

        return reportBuf.toString();

    }

}
