package com.myarch.dpbuddy.xmltransform;

import org.apache.commons.logging.Log;
import org.apache.tools.ant.Project;

import com.myarch.antutil.AntUtils;
import com.myarch.dpbuddy.ant.BaseDPBuddyTask;

public class TransformLogger {
    private boolean isVerbose=false;
    private Project project;
    private Log logger;

    public TransformLogger(Project project, Log logger) {
        this( logger );
        this.project=project;
    }

    public TransformLogger(Log logger) {
        super();
        this.logger=logger;
    }

    public void setVerbose( boolean isVerbose ) {
        this.isVerbose=isVerbose;
    }

    public boolean isVerbose() {
        return isVerbose;
    }

    public void setProject( Project project ) {
        this.project=project;
    }

    public final static String VERBOSE_TRANSFORM_PROP="dp.verbose.transform";

    private boolean isVerboseLogging() {
        return isVerbose || AntUtils.isPropertyTrue( project, VERBOSE_TRANSFORM_PROP );
    }

    protected void log( String msg, Object... args ) {
        String completeMsg=String.format( msg, args );
        if (isVerboseLogging()) {
            if (project != null)
                project.log( completeMsg, determineInfoLogLevel( project ) );
            else
                logger.info( completeMsg );
        }
        else {
            logger.debug( completeMsg );
        }
    }

    private int determineInfoLogLevel( Project project ) {
        int antLogLevel=Project.MSG_INFO;
        if (BaseDPBuddyTask.isGradleLogging( project )) {
            antLogLevel=Project.MSG_WARN;
        }

        return antLogLevel;
    }

}
