package com.myarch.dpbuddy.xmlutil;

import java.io.IOException;

import org.apache.commons.io.output.ByteArrayOutputStream;
import org.jdom2.Document;
import org.jdom2.Element;
import org.jdom2.Namespace;
import org.jdom2.output.Format;
import org.jdom2.output.XMLOutputter;

public class SoapUtils {
    public final static Namespace SOAP_NAMESPACE=Namespace.getNamespace( "env", "http://schemas.xmlsoap.org/soap/envelope" );

    public final static String SOAP_HEADER="<env:Envelope xmlns:env=\"http://schemas.xmlsoap.org/soap/envelope/\"><env:Body>";
    public final static String SOAP_FOOTER="</env:Body></env:Envelope>";
    
    public static Document wrapInSoap(Document doc) {
        Element envelope=new Element("Envelope", SOAP_NAMESPACE);
        Element body=new Element("Body", SOAP_NAMESPACE);
        envelope.addContent( body );
        Document soapDoc=new Document(envelope);
        
        body.addContent( doc.detachRootElement());
        
        return soapDoc;
    }
    

    public static String wrapInSoap( String s ) {
        return SOAP_HEADER + "\n" + s + SOAP_FOOTER;
    }
    

    public static byte[] serializeToBytesWithSoap( Document doc ) {
        ByteArrayOutputStream baos=new ByteArrayOutputStream();
        try {
            baos.write( SOAP_HEADER.getBytes() );
            Format format=Format.getCompactFormat();
            format.setOmitDeclaration( true );
            XMLOutputter outputter=new XMLOutputter( format );
            outputter.output( doc, baos );
            baos.write( SOAP_FOOTER.getBytes() );
        }
        catch (IOException ioe) {
            throw new RuntimeException( ioe );
        }
        return baos.toByteArray();
    }

}
