package com.myarch.dpbuddy.xmlutil;

import java.io.IOException;
import java.io.Writer;

import org.jdom2.Attribute;
import org.jdom2.Element;
import org.jdom2.Namespace;
import org.jdom2.output.support.AbstractXMLOutputProcessor;
import org.jdom2.output.support.FormatStack;
import org.jdom2.util.NamespaceStack;

public class XMLOutputProcessorHelper extends AbstractXMLOutputProcessor{

    protected void printOpenTag( Writer out, FormatStack fstack, NamespaceStack nstack, Element elt )
                    throws IOException {
        // Print the beginning of the tag plus attributes and any
        // necessary namespace declarations
        write( out, "<" );

        write( out, elt.getQualifiedName() );

        // Print the element's namespace, if appropriate
        for (final Namespace ns : nstack.addedForward()) {
            printNamespace( out, fstack, ns );
        }

        // Print out attributes
        if (elt.hasAttributes()) {
            for (final Attribute attribute : elt.getAttributes()) {
                printAttribute( out, fstack, attribute );
            }
        }
        write( out, ">" );
    }

    protected void printCloseTag( Writer out, FormatStack fstack, NamespaceStack nstack, Element elt )
                    throws IOException {
        write( out, "</" );
        write( out, elt.getQualifiedName() );
        write( out, ">" );
    }


}
