package com.myarch.eventmodel;

public class EventException extends RuntimeException{
    
    public EventException(String msg, Object ... args) {
        super(makeMessage( msg, args));
    }
    
    public EventException(Throwable e) {
        super(e);
    }
    
    public EventException(String msg, Throwable e, Object ... args) {
        super(makeMessage( msg, args), e);
    }

    private static String makeMessage( String message, Object ...  args){
        if (args.length==0)
            return message;
        else
            return String.format(message, args);
    }
    
    
    
    private static final long serialVersionUID = 1L;
}
