package com.myarch.hocon;

import java.util.Map;
import java.util.Set;

import org.apache.commons.lang.StringUtils;

import com.typesafe.config.Config;
import com.typesafe.config.ConfigUtil;
import com.typesafe.config.ConfigValue;

public class HoconExporter {

    public String export( Config hocon, String template, String pathDelim ) {
        Set<Map.Entry<String, ConfigValue>> hoconEntries=hocon.entrySet();
        StringBuilder buf=new StringBuilder();
        for(Map.Entry<String, ConfigValue> entry: hoconEntries) {
            String exportedVar=exportHoconProp(entry.getKey(), entry.getValue(), template, pathDelim);
            buf.append( exportedVar );
            buf.append( '\n' );
        }
        
        return buf.toString();
    }

    private String exportHoconProp(String path, ConfigValue hoconVal, String template, String pathDelim) {
        String exportedVal=hoconVal.unwrapped().toString();
        String name=pathToVarName(path, pathDelim);
        
        String exported=String.format( template,  name, exportedVal );
        
        return exported;
    }
    
    private String pathToVarName(String path, String safeDelim) {
        return StringUtils.join( ConfigUtil.splitPath( path ), safeDelim);
    }

}
