package com.myarch.hocon;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;

import com.myarch.antutil.AntCommonsLogger;
import com.myarch.dpbuddy.DPBuddyException;
import com.myarch.dpbuddy.ant.BaseDPBuddyTask;

public class HoconScopeAntTask extends Task{
    
    
    private String scopePath;
    
    public void setScopePath( String scope) {
        this.scopePath=scope;
    }
    
    public HoconScopeAntTask() {
        AntCommonsLogger.init( BaseDPBuddyTask.ROOT_LOGGER );
    }
    
    
    @Override
    public void execute() throws BuildException {
        BaseDPBuddyTask.setUpLogging( getProject() );
        if (scopePath== null)
            throw new BuildException( "You must provide 'scope' attribute");
        
        try{
            HoconAntUtils.setScope( getProject(), scopePath);
        }
        catch (Exception e) {
            if (e instanceof BuildException) {
                throw (BuildException) e;
            }
            else {
                // we're wrapping in DPBuddyException to force Ant not to dump the error stack for certain exceptions in non-verbose mode
                throw new BuildException(e.getMessage(), new DPBuddyException(e) );
            }
        }
        finally {
            AntCommonsLogger.deregister();
        }
    }

}
