package com.myarch.hocon;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;

import com.myarch.antutil.AntCommonsLogger;
import com.myarch.dpbuddy.DPBuddyException;
import com.myarch.dpbuddy.ant.BaseDPBuddyTask;

public class HoconTextAntTask extends Task {

    private String hoconStr="";

    public void setText( String text ) {
        this.hoconStr=text;
    }

    public void addText(String hoconText) {
        hoconStr += getProject().replaceProperties(hoconText);
    }
    
    
    public HoconTextAntTask() {
        AntCommonsLogger.init( BaseDPBuddyTask.ROOT_LOGGER );
    } 
    // TODO: Nested text

    @Override
    public void execute() throws BuildException {
        BaseDPBuddyTask.setUpLogging( getProject() );
        if (hoconStr == null)
            throw new BuildException( "You must provide 'text' attribute containing configuration" );
        try {
            HoconAntUtils.addConfig( getProject(), hoconStr );
        }
        catch (Exception e) {
            if (e instanceof BuildException) {
                throw (BuildException) e;
            }
            else {
                // we're wrapping in DPBuddyException to force Ant not to dump
                // the error stack for certain exceptions in non-verbose mode
                throw new BuildException( e.getMessage(), new DPBuddyException( e ) );
            }
        }
        finally {
            AntCommonsLogger.deregister();
        }

    }

}
