package com.myarch.propmanagement;

import java.util.Map;

public class Prop {
    
    
    private String name;
    private Object value;
    private PropSourceLocation location;
    
    public static Prop createFromSource(Map<Object, Object> source, String key ) {
        Object val = source.get(key);
        if (val==null)
            throw new IllegalArgumentException("Key "+key+" must exist in map "+source);
        // TODO: Support for location
        return new Prop( key, val );
    }
    
   
    public static Prop createFromString(String propStr) {
        String[] keyval = propStr.split("=");
        if (keyval.length!=2) 
            throw new ValidationException("Expected property in 'name=value' format. You provided: '%s'", propStr);
        Prop prop = new Prop(keyval[0].trim(), keyval[1].trim());
        return prop;
        
    }
    
    public Prop(String name, Object value) {
        this.name = name;
        this.value = value;
    }

    public Prop(String name, Object value, PropSourceLocation location) {
        this(name, value);
        this.location=location;
    }

    public PropSourceLocation getLocation() {
        return location;
    }

    public String getName() {
        return name;
    }
    public Object getValue() {
        return value;
    }
    
    public String toString() {
        return name+"="+value;
    }
    
    
}
