package com.myarch.propmanagement;



public class ValidationException extends RuntimeException {
    
    private String problem;
    private Prop prop;

    public ValidationException(Prop prop, String problem, Object ...  args) {
        this.prop = prop;
        if (args.length>0) {
            this.problem = String.format(problem, args);
        } else {
            this.problem = problem;
        }
    }

    
    public ValidationException(String problem,  Object ...  args) {
        this(null, problem, args);
    }

    public String getProblem() {
        return problem;
    }

    public Prop getProp() {
        return prop;
    }
    
    public String getMessage(){
        // TODO: add prop?
        return getProblem();
    }
    
    public String toString(){
        return getMessage();
    }
    
    private static final long serialVersionUID = 5740117090335476189L;
    
}
