package com.myarch.util;

import java.text.ParseException;
import java.util.Date;

import org.apache.commons.lang3.time.DateParser;
import org.apache.commons.lang3.time.FastDateFormat;

public class DateUtils {
    
    private static final DateParser ZULU_FORMAT_DATE_PARSER = FastDateFormat.getInstance("yyyyMMdd'T'HHmmss.SSS'Z'");
        
    public static Date parseZuluDateTime( String zuluDateTimeStr ) {
        return parseDate(zuluDateTimeStr, ZULU_FORMAT_DATE_PARSER);
    }
    
    public static Date parseDate(String dateStr, DateParser dateParser) {
        Date parsedDate;
        try {
            parsedDate=dateParser.parse( dateStr );
        }
        catch (ParseException e) {
            return null;
        }       
        
        return parsedDate;
    }

}
