package com.myarch.util;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import org.apache.commons.codec.binary.Base64InputStream;
import org.apache.commons.codec.binary.Base64OutputStream;
import org.apache.tools.ant.filters.StringInputStream;

public class EncoderUtils {
    
    public static String encode(InputStream inputStream) {
        StringBuilder encodedString=new StringBuilder();
        try {
            Base64InputStream base64is=new Base64InputStream( inputStream, true, -1, null);
            try {
                
                int b;
                while((b=base64is.read())!=-1) {
                    encodedString.append((char)b);
                }
            }
            finally  {
                base64is.close();
            }
            
        } catch (IOException e) {
            throw new RuntimeException( e );
        } 
        
        return encodedString.toString();
    }
    
    public static void decode(String stringToDecode, OutputStream outputStream) throws IOException{
        
        Base64OutputStream base64os=new Base64OutputStream( outputStream, false);
        try {
            base64os.write(stringToDecode.getBytes());
        }
        finally  {
            base64os.close();
        }
        
        
    }

    
    public static String decode(String stringToDecode) throws IOException{
        ByteArrayOutputStream baos=new ByteArrayOutputStream();
        decode(stringToDecode, baos);
        return baos.toString();
    }

    
    public static String encode(String stringToEncode) throws IOException{
        return encode(new StringInputStream(stringToEncode));
        
    }

    
}
