package com.myarch.util;

import java.util.ArrayList;
import java.util.List;

import org.apache.commons.lang3.StringUtils;
import org.apache.commons.lang3.tuple.ImmutablePair;
import org.apache.commons.lang3.tuple.Pair;

import com.myarch.dpbuddy.DPBuddyException;

public class NameValueListParser {

    public static List<Pair<String, String>>  parse( String pairsList, String valueDefault ) {
        List<Pair<String, String>> pairs=new ArrayList<>();
        
        String[] elementsWithColons=StringUtils.split( pairsList, ',' );
        for (String elementWithColon : elementsWithColons) {
            String[] nameAndValue=StringUtils.splitPreserveAllTokens( elementWithColon.trim(), ':' );
            String name=null;
            String value=null;
            if (nameAndValue.length > 0) {
                // class only
                if (nameAndValue.length==1) {
                    value=valueDefault;
                    if (StringUtils.isNotBlank(nameAndValue[0]) ) {
                        name=nameAndValue[0].trim();   
                    }
                }
                else if(nameAndValue.length==2){
                    if (StringUtils.isNotBlank(nameAndValue[0]) ) {
                        name=nameAndValue[0].trim();   
                    }
                    
                    if (StringUtils.isNotBlank(nameAndValue[1]) ) {
                        value=nameAndValue[1].trim();   
                    }
                }
                else  {
                    throw new DPBuddyException ("Invalid token '%s' containing multiple ':', only one ':' separator is allowed", elementWithColon);
                }
                pairs.add(ImmutablePair.of( name, value ) );
            }
        }

        return pairs;
    }

}
