package com.myarch.util;

import java.text.MessageFormat;
import java.util.Date;
import java.util.HashSet;
import java.util.LinkedHashSet;
import java.util.Set;
import java.util.regex.Pattern;

import org.apache.commons.lang3.StringUtils;

import com.myarch.dpbuddy.DPBuddyException;


public class StringPatternUtils {
    
    public static Set<String> split( String s ) {
        String delim = ",";
        String[] tokens = StringUtils.splitByWholeSeparator( s, delim );
        
        Set<String> tokenList = new HashSet<String>();
        for( String token:tokens)
            tokenList.add(token.trim());
        return tokenList;
    }
    
    
    public static String appendTimestamp( String name ){
        String format="{0}_{1,date,yyyyMMdd_HHmmss}";
        return appendTimestamp(name, format);
    }   
    
    public static String appendTimestamp( String name, String format ){
        return MessageFormat.format( format, name, new Date() );
    }
    
    public static Set<Pattern> stringToPattnernList( String patternsString ) {
        Set<Pattern> patternList = new LinkedHashSet<Pattern>();
        for( String pattern: StringPatternUtils.split(patternsString)) {
            patternList.add( compileRegexp(pattern));
        }
        
        return patternList;
    }
           
    
    public static String appendOrPattern(String pattern, String patternToAppend){
        pattern=StringUtils.removeEnd(pattern, ")");
        pattern+="|"+patternToAppend;
        if (!pattern.startsWith( "(" ))
            pattern="("+pattern;
        if (!pattern.endsWith( ")" ))
            pattern+=")";
        return pattern;
    }
    
    
    public static Pattern compileRegexp( String regexp ){
        
        if (regexp.contains("${"))
            throw new DPBuddyException("Encountered an unresolved variable in the regular expression '%s'", regexp);
        return Pattern.compile(regexp);
    }
    
}
